{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//                CONIO.H IMPORT UNIT for GPC                           //}
{//                                                                      //}
{//  v1.00 - by Dr Abimbola A. Olowofoyeku (The African Chief);          //}
{//                                                                      //}
{//  This package is released as part of the GNU Pascal project.         //}
{//                                                                      //}
{//  NOTE - SOME OF THE ROUTINES IN THIS UNIT MAY NOT WORK CORRECTLY.    //}
{//  TEST CAREFULLY AND USE WITH CARE !!!                                //}
{//                                                                      //}
{//  This library is a free library; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  v1.00, May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk               //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}
UNIT CONIO;

INTERFACE

{$W-}

Const NOCURSOR = 0;
Const SOLIDCURSOR = 1;
Const NORMALCURSOR = 2;

Type text_info = record
                   winleft : Byte;
                   wintop : Byte;
                   winright : Byte;
                   winbottom : Byte;
                   attribute : Byte;
                   normattr : Byte;
                   currmode : Byte;
                   screenheight : Byte;
                   screenwidth : Byte;
                   curx : Byte;
                   cury : Byte;
                 end {text_info};

Type text_modes = ( LASTMODE{=-1}, 
                   BW40{=0}, 
                   C40, 
                   BW80, 
                   C80, 
                   MONO{=7}, 
                   C4350{=64 } );

Type COLORS = ( 
    BLACK,          
    BLUE,
    GREEN,
    CYAN,
    RED,
    MAGENTA,
    BROWN,
    LIGHTGRAY,
    {/*  light colors    */}
    DARKGRAY,
    LIGHTBLUE,
    LIGHTGREEN,
    LIGHTCYAN,
    LIGHTRED,
    LIGHTMAGENTA,
    YELLOW,
    WHITE

 );

Const BLINK = $80; {/* blink bit */}


procedure blinkvideo; C;

function cgets ( _str : PChar ) : PChar; C;

procedure clreol; C;

procedure clrscr; C;

function _conio_kbhit : Boolean; C;
{= checks for ungetch char }

function kbhit : Boolean; AsmName '_conio_kbhit';

{
function cprintf(Const _format: PChar;
                 __attribute__((format(printf: ...);
                 _3: 1;
                 _4: 2))): Integer; C;


function cscanf(Const _format: PChar;
                __attribute__((format(scanf: ...);
                _3: 1;
                _4: 2))): Integer; C;
}

function cputs ( _str : PChar ) : char; C;

procedure delline; C;

function getch : Char; C;

function getche : Char; C;

function gettext ( _left : Integer; 
                 _top : Integer; 
                 _right : Integer; 
                 _bottom : Integer; 
                 Var _destin ) : Integer; C;

procedure gettextinfo ( Var _r : TEXT_INFO ); C;

procedure gotoxy ( _x : Integer; 
                 _y : Integer ); C;

procedure gppconio_init; C;

procedure highvideo; C;

procedure insline; C;

procedure intensevideo; C;

procedure lowvideo; C;

function movetext ( _left : Integer; 
                  _top : Integer; 
                  _right : Integer; 
                  _bottom : Integer;
                  _destleft : Integer; 
                  _desttop : Integer ) : Integer; C;

procedure normvideo; C;

function putch ( _c : Char ) : Char; C;

function puttext ( _left : Integer; 
                 _top : Integer; 
                 _right : Integer; 
                 _bottom : Integer; 
                 Var _source ) : Integer; C;

procedure _setcursortype ( _type : Integer ); C;

procedure _set_screen_lines ( _nlines : Integer ); C;

procedure textattr ( _attr : Integer ); C;

procedure textbackground ( _color : Integer ); C;

procedure textcolor ( _color : Integer ); C;

procedure textmode ( _mode : Integer ); C;

function ungetch ( _1 : Char ) : Char; C;

function wherex : Integer; C;

function wherey : Integer; C;

procedure window ( _left : Integer; 
                 _top : Integer; 
                 _right : Integer; 
                 _bottom : Integer ); C;

IMPLEMENTATION

End.
