{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//          (Incomplete) BORLAND COMPATIBLE "DOS" UNIT for GPC          //}
{//  check for comments which are marked with "!!!" for some differences //}
{//                                                                      //}
{//  v1.00 - by Dr Abimbola A. Olowofoyeku (The African Chief);          //}
{//                                                                      //}
{//  This package is released as part of the GNU Pascal project.         //}
{//                                                                      //}
{//  NOTE - SOME OF THE ROUTINES IN THIS UNIT MAY NOT WORK CORRECTLY.    //}
{//  TEST CAREFULLY AND USE WITH CARE !!!                                //}
{//                                                                      //}
{//  This library is a free library; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  v1.00, May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk               //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}
UNIT DOS;

INTERFACE

USES GPCTYPES, SYSTEM, XSYSTEM, STRINGS, DOSH;

{$X+}    { use extended syntax }
{$W-}    { disable warnings }

{ file attribute constants }
Const
Normal      = $00;
ReadOnly    = $01;
Hidden      = $02;
SysFile     = $04;
VolumeID    = $08;
Directory   = $10;
Archive     = $20;
AnyFile     = $3F;

Type
TSearchRec = packed record
   RESERVED : packed array [0..20] of char;
   ATTR     : Byte;
   TIME     : ShortWord;
   DATE     : ShortWord;
   SIZE     : ShortWord;
   OrgName  : packed array [0..251] of char;{!!!}
   Name     : PChar;
end {_find_t};
SearchRec  = TSearchRec; { DOS !!! -"Name" field is a pchar !!!}

Var
DosError : integer; { !!! Not really used that much - incomplete !!! }

{!!! doesn't work well: Procedure in BP !!!}
Function  FindFirst ( Path : PChar; Attr : Word; var F : TSearchRec ) : integer;
AsmName '_p_findfirst';

{!!! doesn't work well: Procedure in BP  !!!}
Function  FindNext  ( var F : TSearchRec ) : integer;
AsmName '_p_findnext';

{ !!! Delphi !!! }
Function  FindClose  ( var F : TSearchRec ) : integer;
AsmName '_p_findclose';


Function  GetEnvVar ( Env : pChar ) : pChar;
Function  GetEnvStr ( Env : String ) : String;
Function  GetEnv    ( name : pChar ) : pChar; C;
Function  SetEnv    ( name : PChar ) : integer;AsmName 'putenv';
Function  FileSplit ( path : PChar;dir : PChar;name : PChar;ext : PChar ) : Integer;
Function  DiskFree  ( Drive : Byte ) : Longint;
Function  DiskSize  ( Drive : Byte ) : Longint;
Procedure Exec ( Prog, Params : string );
Procedure GetCBreak ( var aBreak : Boolean );
Procedure SetCBreak ( aBreak : Boolean );
Procedure SetEnvVar ( Name : String );

Procedure GetDate   ( var Year, Month, Day, DayOfWeek : Word );
AsmName '_p_getdate';

Procedure GetTime   ( var Hour, Minute, Second, Sec100 : Word );
AsmName '_p_gettime';

Procedure SetDate   ( Year, Month, Day : Word );
AsmName '_p_setdate';

Procedure SetTime   ( Hour, Minute, Second, Sec100 : Word );
AsmName '_p_settime';

{ !!! }
Procedure GetFTime  ( Var F : BinFile; Var Time : TFileTime );
AsmName '_p_getftime';

{ !!! }
Procedure SetFTime  ( Var F : BinFile; Var Time : TFileTime );
AsmName '_p_setftime';

Procedure GetFAttr  ( Var F : BinFile; Var Attr : Word );
AsmName '_p_getfattr';

Procedure SetFAttr  ( Var F : BinFile; Attr : Word );
AsmName '_p_setfattr';

{ get the current working directory in "drive" and return
  it in "dest"; drive:0=current drive;1=A;2=B;3=C;etc }
Procedure GetDir ( drive : byte; Var Dest : string );

{ WinDOS }
Function  CreateDir ( path : PChar ) : Integer; AsmName 'mkdir';
Function  SetCurDir ( path : PChar ) : Integer; AsmName 'chdir';
Function  RemoveDir ( path : PChar ) : Integer; AsmName 'rmdir';
Function  RemoveFile ( path : PChar ) : Integer; AsmName 'unlink';
{ return the current working directory in "drive" }
{ drive:0=current drive;1=A;2=B;3=C;etc }
Function  GetCurDir ( Dir : pChar; Drive : Byte ) : PChar;
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{ helper functions to manipulate TSearchRec.Name field }
{ !!! convert array [0..x] of char to a string !!! }
Function ChArray2String ( Var a : Array of char ) : string;

{ !!! convert array [0..x] of char to a pChar !!! }
Function ChArray2pChar ( Var a : Array of char ) : pChar;
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
IMPLEMENTATION
{ helper functions from C library }
Function  system ( name : pChar ) : integer; C;
Function  GetDisk : Integer; C;
Function  SetDisk ( drive : Integer ) : Integer; C;
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{ convert array [0..x] of char to a string - kludge to make
  FindFirst and FindNext usable }
Function ChArray2String ( Var a : Array of char ) : string;
var
p : string;
i, j, k : integer;
b : boolean;
begin
    i := 0;
    b := true;
    j := 0;
    k := 0;
    p := '';
    while ( b = true )
    do begin {the first two chars are nulls!}
      if ( ord ( a [i] ) = 0 ) then inc ( j );
      if ( ord ( a [i] ) = 0 ) and ( j <= 3 )
      then {} else begin
         if ( b = true ) and  ( Ord ( a [i] ) > 19 ) {ignore garbage}
         then begin
            p := p + a [i];
            inc ( k );
         end;
      end;
      inc ( i );
      if j >= 3 then b := false;
    end;

    p := p + 'x' + chr ( 0 );
    p [k + 1] := Chr ( 0 );
    ChArray2String := p;
end; {* ChArray2String *}
{///////////////////////////////}
{ convert array [0..x] of char to a pChar }
Function ChArray2pChar ( Var a : Array of char ) : pChar;
var
p : string;
begin
    p := ChArray2String ( a ) + Chr ( 0 );
    ChArray2pChar := @p [1];
end; {* ChArray2pChar *}
{///////////////////////////////}
Function  FindFirst;
Begin
   With F do begin
      DosError  := _dos_findfirst ( Path, Attr, F );
      FindFirst := DosError;
      If ( DosError = 0 ) then begin
         MemAlloc ( Name, 256 );   { get memory for name }
         Name := ChArray2pChar ( OrgName );
      end;
   end;
End; {* FindFirst *}
{///////////////////////////////}
Function  FindNext;
Begin
   With F do begin
      DosError := _dos_findnext ( F );
      FindNext := DosError;
      If ( DosError = 0 ) then begin
         Name := ChArray2pChar ( OrgName );
      end else begin
         MemFree ( Name ); { free memory for name }
         Name := Nil;
      end;
   end;
End; {* FindNext *}
{///////////////////////////////}
Function  FindClose;
Begin
   With F do begin
      If ( Name <> Nil ) then begin
         MemFree ( Name ); { free memory for name }
         Name := Nil;
         FindClose := 0;
      end
      else FindClose := -1;
   end;
End; {* FindClose *}
{///////////////////////////////}
{///////////////////////////////}
Procedure GetCBreak ( var aBreak : Boolean );
Begin
   aBreak := ( getcbrk = 1 );
End; {*  GetCBreak *}
{///////////////////////////////}
Procedure SetCBreak ( aBreak : Boolean );
Begin
   if setcbrk ( ord ( aBreak ) ) = 0 then;
End; {*  SetCBreak *}
{///////////////////////////////}
Procedure Exec ( Prog, Params : String );
Var
s : string;
Begin
    s := Prog + ' ' + Params + Chr ( 0 );
    DosError := system ( @s [1] );
End; {*  Exec *}
{///////////////////////////////}
Function  GetEnvVar ( Env : pChar ) : pChar;
Begin
   GetEnvVar := GetEnv ( Env );
End; {* GetEnvVar *}
{///////////////////////////////}
Function  GetEnvStr ( Env : String ) : String;
Begin
   Env := Env + chr ( 0 );
   GetEnvStr := StrPas ( GetEnv ( @Env [1] ) );
End;  {*  GetEnvStr *}
{///////////////////////////////}
Procedure SetEnvVar ( Name : String );
Begin
   Name := Name + Chr ( 0 );
   If SetEnv ( @Name [1] ) = 0 then;
End; {* SetEnvVar *}
{///////////////////////////////}
Function  FileSplit ( path : PChar;dir : PChar;name : PChar;ext : PChar ) : Integer;
Var
p : pchar;
p2 : pchar;
Begin
   Getmem ( p, 8 );
   FileSplit := fnsplit ( path, p, dir, name, ext );
   If p^ <> chr ( 0 )
   then begin
     Getmem ( p2, 255 );
     p2  := strcopy ( p2, p ); {drive}
     p2  := ChangeFrontSlashPChar ( strcat  ( p2, dir ) ); {directory}
     dir := strcopy ( dir, p2 );
     freemem ( p2, 255 );
   end;
   freemem ( p, 8 );
End; {* FileSplit *}
{///////////////////////////////}
Function GetCurDir ( Dir : pChar; Drive : Byte ) : PChar;
Var
i, j : integer;
Begin
   i := GetDisk;
   if ( drive = 0 ) then drive := getdisk; {0=current drive}
   j := SetDisk ( Drive );
   Dir := getcwd ( Dir, 255 );
   Dir := ChangeFrontSlashPChar ( Dir );
   GetCurDir := Dir;
   j := SetDisk ( i );
End; {* GetCurDir *}
{////////////////////////////////}
Procedure GetDir ( drive : byte; Var Dest : string );
Var
p : pchar;
Begin
   getmem ( p, 255 );
   if ( drive = 0 ) then drive := getdisk; {0=current drive}
   p := GetCurDir ( p, drive );
   Dest := ChangeFrontSlash ( Strpas ( p ) );
   freemem ( p, 255 );
End; {* GetDir *}
{///////////////////////////////}
Function DiskFree ( Drive : Byte ) : Longint;
Var
df : dFree;
Begin
   GetDFree ( Drive, df );
   With dF do
   DiskFree := avail * bsec * sclus;
End; {* DiskFree *}
{///////////////////////////////}
Function  DiskSize ( Drive : Byte ) : Longint;
Var
df : dFree;
Begin
   GetDFree ( Drive, df );
   With dF do
   DiskSize := total * bsec * sclus;
End; {* DiskSize *}
{///////////////////////////////}
Procedure GetDate ( var Year, Month, Day, DayOfWeek : Word );
Var
d : _dosdate_t;
Begin
  _dos_getdate ( d );
  Year   := d.Year;
  Month  := d.Month;
  Day    := d.Day;
  DayOfWeek := d.DayOfWeek;
End; {* GetDate *}
{///////////////////////////////}
Procedure GetTime ( var Hour, Minute, Second, Sec100 : Word );
Var
d : _dostime_t;
Begin
   _dos_gettime ( d );
   Hour   := d.Hour;
   Minute := d.Minute;
   Second := d.Second;
   Sec100 := D.hsecond;
End; {* GetTime *}
{///////////////////////////////}
Procedure SetDate ( Year, Month, Day : Word );
Var
d : date;
Begin
    d.Year  := Year;
    d.Month := Month;
    d.Day   := Day;
    _setdate ( d );
End; {* SetDate *}
{///////////////////////////////}
Procedure SetTime ( Hour, Minute, Second, Sec100 : Word );
Var
d : _dostime_t;
Begin
   d.Hour   := Hour;
   d.Minute := Minute;
   d.Second := Second;
   d.hsecond := Sec100;
   If _dos_settime  ( d ) = 0 then;
End; {* SetTime *}
{///////////////////////////////}
Procedure GetFTime ( Var F : BinFile; Var Time : TFileTime );
Begin
  DosError := GetFileTime ( F.Handle, Time );
End; {* GetFTime *}
{///////////////////////////////}
Procedure SetFTime ( Var F : BinFile; Var Time : TFileTime );
Begin
  DosError := SetFileTime ( F.Handle, Time );
End; {* SetFTime *}
{///////////////////////////////}
Procedure GetFAttr ( Var F : BinFile; Var Attr : Word );
Var
s : string [256];
Begin
    With F do begin
       s := Name + chr ( 0 );
       DosError := _dos_getfileattr ( @s [1], Attr );
    end;
End;{* GetFAttr *}
{///////////////////////////////}
Procedure SetFAttr ( Var F : BinFile; Attr : Word );
Var
s : string [256];
Begin
    With F do begin
        s := Name + chr ( 0 );
        DosError := _dos_setfileattr ( @s [1], Attr );
    end;
End;{* SetFAttr *}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{$W+}
End.
