/* C code produced by gperf version 2.5 (GNU C++ version) */
/* Command-line: gperf -p -j1 -g -G -o -t -N is_reserved_word ./gpc.gperf  */ 
/* ISO Pascal 7185 && Extended Pascal (Jan 29, 1989 Draft) reserved words.

   Copyright (C) 1989, 1993, Free Software Foundation, Inc.

This file is part of GNU GPC.

GNU GPC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 1, or (at your option)
any later version.

GNU GPC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU GPC; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
 * For GNU Pascal compiler (GPC) by Jukka Virtanen, jtv@hut.fi
 *
 * run this through the Doug Schmidt's gperf program
 * with command
 * gperf  -g -o -j1 -t -p -N is_reserved_word
 *
 * Thanks, Doug.
 */

/* ISO 7185 Standard Pascal keywords are recognized as keywords.
 *
 * To treat ISO 10206 Extended Pascal keywords as keywords,
 * you must give -fextended-pascal when compiling.
 *
 * To treat Object Pascal keywords as keywords, give
 * -fobject-pascal.
 *
 * And so on.
 *
 * Otherwise they are recognized, but may be redfined.
 * This violates Extended Pascal standard, but works anyhow,
 * if your program does not redefine them. And it also makes
 * ISO standard pascal program compile without modifications 
 * with GPC.
 *
 * Keywords are dynamically enabled and disabled such that a
 * correct ISO Pascal program will not notice foreign keywords
 * at all.  If you change this, extensions won't work.
 */

struct resword { char *name;
		 short token;
		 char informed;
		 char disabled;
		 unsigned long iclass;
	       };

#define TOTAL_KEYWORDS 82
#define MIN_WORD_LENGTH 2
#define MAX_WORD_LENGTH 14
#define MIN_HASH_VALUE 2
#define MAX_HASH_VALUE 93
/* maximum key range = 92, duplicates = 0 */

#ifdef __GNUC__
inline
#endif
static unsigned int
hash (str, len)
     register char *str;
     register int unsigned len;
{
  static unsigned char asso_values[] =
    {
     94, 94, 94, 94, 94, 94, 94, 94, 94, 94,
     94, 94, 94, 94, 94, 94, 94, 94, 94, 94,
     94, 94, 94, 94, 94, 94, 94, 94, 94, 94,
     94, 94, 94, 94, 94, 94, 94, 94, 94, 94,
     94, 94, 94, 94, 94, 94, 94, 94, 94, 94,
     94, 94, 94, 94, 94, 94, 94, 94, 94, 94,
     94, 94, 94, 94, 94, 52, 57, 65, 62, 67,
     55, 20, 94,  0, 94, 94,  3, 24, 14, 40,
      4,  5, 23, 41,  0, 22, 76, 23,  3, 94,
     94, 94, 94, 94, 94, 94, 94, 94, 94,  0,
     12,  0, 36,  6,  7, 94, 94, 94,  0,  8,
     29,  0, 94, 94, 14,  3,  6, 94,  5,  0,
     13,  4, 94, 94, 94, 94, 94, 94,
    };
  return len + asso_values[str[len - 1]] + asso_values[str[0]];
}

static struct resword wordlist[] =
{
      {"",}, {"",}, 
      {"To", 		TO,		0,  0,	ANY_PASCAL},
      {"",}, 
      {"Type", 		TYPE,		0,  0,	ANY_PASCAL},
      {"Is", 		OP_IS,		0,  0,	O_D_G_PASCAL},
      {"Inline", 		BP_INLINE,	0,  1,	B_D_G_PASCAL},
      {"Pow",     	POW,    	0,  0,	E_O_G_PASCAL},
      {"Label", 		LABEL,		0,  0,	ANY_PASCAL},
      {"Interface", 	INTERFACE,	0,  1,	E_O_U_B_D_G_PASCAL},
      {"Public", 		BP_PUBLIC,	0,  0,	B_D_G_PASCAL},
      {"Private", 	BP_PRIVATE,	0,  0,	B_D_G_PASCAL},
      {"Import",  	IMPORT, 	0,  0,	E_O_G_PASCAL},
      {"Procedure",  	PROCEDURE, 	0,  0,	ANY_PASCAL},
      {"Library", 	BP_LIBRARY,	0,  1,	B_D_G_PASCAL},
      {"Interrupt", 	BP_INTERRUPT,	0,  0,	B_D_PASCAL},
      {"Property", 	OP_PROPERTY, 	0,  0,	O_D_G_PASCAL},
      {"Nil", 		NIL,		0,  0,	ANY_PASCAL},
      {"Index", 		p_INDEX,	0,  1,	B_D_G_PASCAL},
      {"Program",    	PROGRAM,   	0,  0,	ANY_PASCAL},
      {"Xor", 		BP_XOR,		0,  0,	B_D_G_PASCAL},
      {"Inherited", 	OP_INHERITED,	0,  1,	O_B_D_G_PASCAL},
      {"Packed", 		PACKED,		0,  0,	ANY_PASCAL},
      {"Not", 		NOT,		0,  0,	ANY_PASCAL},
      {"Goto", 		GOTO,		0,  0,	ANY_PASCAL},
      {"Protected",  	PROTECTED, 	0,  1,	E_O_D_G_PASCAL},
      {"Qualified",  	QUALIFIED, 	0,  0,	E_O_G_PASCAL},
      {"Until", 		UNTIL,		0,  0,	ANY_PASCAL},
      {"While", 		WHILE,		0,  0,	ANY_PASCAL},
      {"Uses", 		BP_USES,	0,  0,	U_B_D_G_PASCAL},
      {"Module",  	MODULE, 	0,  0,	E_O_G_PASCAL},
      {"In", 		IN,		0,  0,	ANY_PASCAL},
      {"Unit", 		BP_UNIT,	0,  0,	U_B_D_G_PASCAL},
      {"Then", 		THEN,		0,  0,	ANY_PASCAL},
      {"With", 		WITH,		0,  0,	ANY_PASCAL},
      {"Repeat", 		REPEAT,		0,  0,	ANY_PASCAL},
      {"",}, 
      {"Resident", 	BP_RESIDENT,	0,  0,	B_D_PASCAL},
      {"If", 		IF,		0,  0,	ANY_PASCAL},
      {"Mod", 		MOD,		0,  0,	ANY_PASCAL},
      {"",}, 
      {"Record", 		RECORD,		0,  0,	ANY_PASCAL},
      {"",}, 
      {"Implementation", 	IMPLEMENTATION,	0,  1,	E_O_U_B_D_G_PASCAL},
      {"Shl", 		BP_SHL,		0,  0,	B_D_G_PASCAL},
      {"Restricted",    	RESTRICTED,	0,  0,	E_O_G_PASCAL},
      {"",}, 
      {"Or_else",  	OR_ELSE, 	0,  0,	E_O_G_PASCAL},
      {"Only",    	ONLY,   	0,  0,	E_O_G_PASCAL},
      {"Otherwise",  	OTHERWISE, 	0,  0,	E_O_G_PASCAL},
      {"Set", 		SET,		0,  0,	ANY_PASCAL},
      {"Overlay", 	BP_OVERLAY,	0,  0,	BORLAND_PASCAL},
      {"Object", 		BP_OBJECT,	0,  1,	B_D_G_PASCAL},
      {"String", 		STRING_KEYWORD,	0,  1,	B_D_G_PASCAL},
      {"Segment", 	UCSD_SEGMENT,	0,  0,	UCSD_PASCAL},
      {"All", 		ALL,		0,  1,	GNU_PASCAL},
      {"Or", 		OR,		0,  0,	ANY_PASCAL},
      {"",}, 
      {"Shr", 		BP_SHR,		0,  0,	B_D_G_PASCAL},
      {"File", 		FILE_,		0,  0,	ANY_PASCAL},
      {"Absolute", 	BP_ABSOLUTE,	0,  1, 	B_D_G_PASCAL},
      {"Array", 		ARRAY,		0,  0,	ANY_PASCAL},
      {"Operator", 	PXSC_OPERATOR,	0,  0,	SC_G_PASCAL},
      {"Asm", 	        ASM_KEYWORD,	0,  0,	B_D_GH_PASCAL},
      {"Do", 		DO,		0,  0,	ANY_PASCAL},
      {"Bindable",  	BINDABLE,	0,  0,	E_O_G_PASCAL},
      {"Abstract", 	OP_ABSTRACT,	0,  1,	O_G_PASCAL},
      {"And", 		AND,		0,  0,	ANY_PASCAL},
      {"Downto",  	DOWNTO,		0,  0,	ANY_PASCAL},
      {"Case", 		CASE,		0,  0,	ANY_PASCAL},
      {"Div", 		DIV,		0,  0,	ANY_PASCAL},
      {"Else", 		ELSE,		0,  0,	ANY_PASCAL},
      {"For", 		FOR,		0,  0,	ANY_PASCAL},
      {"Class", 		OP_CLASS,	0,  0,	O_D_G_PASCAL},
      {"Forward", 	D_FORWARD,	0,  0,	U_B_D_G_PASCAL},
      {"External", 	D_EXTERNAL,	0,  0,  E_O_U_B_D_G_PASCAL},
      {"Const", 		CONST,		0,  0,	ANY_PASCAL},
      {"Exports",  	BP_EXPORTS, 	0,  0,	B_D_G_PASCAL},
      {"Of", 		OF,		0,  0,	ANY_PASCAL},
      {"Export",  	EXPORT, 	0,  0,	E_O_B_D_G_PASCAL},
      {"View", 		OP_VIEW,	0,  0,	O_G_PASCAL},
      {"Value",   	VALUE,  	0,  0,	E_O_G_PASCAL},
      {"End", 		END,		0,  0,	ANY_PASCAL},
      {"Virtual", 	BP_VIRTUAL,	0,  1,	O_B_D_G_PASCAL},
      {"",}, {"",}, 
      {"Destructor", 	OP_DESTRUCTOR,	0,  1,	O_B_D_G_PASCAL},
      {"",}, {"",}, 
      {"And_then",  	AND_THEN, 	0,  0,	E_O_G_PASCAL},
      {"Constructor", 	OP_CONSTRUCTOR,	0,  1,	O_B_D_G_PASCAL},
      {"Begin", 		BEGIN,		0,  0,	ANY_PASCAL},
      {"Function",  	FUNCTION, 	0,  0,	ANY_PASCAL},
      {"Var", 		VAR,		0,  0,	ANY_PASCAL},
};

#ifdef __GNUC__
inline
#endif
struct resword *
is_reserved_word (str, len)
     register char *str;
     register unsigned int len;
{
  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register int key = hash (str, len);

      if (key <= MAX_HASH_VALUE && key >= 0)
        {
          register char *s = wordlist[key].name;

          if (*s == *str && !strcmp (str + 1, s + 1))
            return &wordlist[key];
        }
    }
  return 0;
}
