typedef union {
    char *filename;
    long  itype;
    int   lineno; 
    enum  tree_code code;
    tree  ttype;
} YYSTYPE;
#define	IDENTIFIER	258
#define	AND	259
#define	ARRAY	260
#define	BEGIN	261
#define	CASE	262
#define	CONST	263
#define	DIV	264
#define	DO	265
#define	DOWNTO	266
#define	ELSE	267
#define	END	268
#define	FILE_	269
#define	FOR	270
#define	FUNCTION	271
#define	GOTO	272
#define	IF	273
#define	IN	274
#define	LABEL	275
#define	MOD	276
#define	NIL	277
#define	NOT	278
#define	OF	279
#define	OR	280
#define	PACKED	281
#define	PROCEDURE	282
#define	PROGRAM	283
#define	RECORD	284
#define	REPEAT	285
#define	SET	286
#define	THEN	287
#define	TO	288
#define	TYPE	289
#define	UNTIL	290
#define	VAR	291
#define	WHILE	292
#define	WITH	293
#define	AND_THEN	294
#define	BINDABLE	295
#define	EXPORT	296
#define	IMPORT	297
#define	MODULE	298
#define	ONLY	299
#define	OR_ELSE	300
#define	OTHERWISE	301
#define	POW	302
#define	RESTRICTED	303
#define	PROTECTED	304
#define	QUALIFIED	305
#define	VALUE	306
#define	OP_ABSTRACT	307
#define	OP_CLASS	308
#define	OP_CONSTRUCTOR	309
#define	OP_DESTRUCTOR	310
#define	OP_INHERITED	311
#define	OP_IS	312
#define	OP_PROPERTY	313
#define	OP_VIEW	314
#define	D_EXTERNAL	315
#define	D_FORWARD	316
#define	UCSD_SEGMENT	317
#define	BP_EXPORTS	318
#define	BP_INDEX	319
#define	BP_INLINE	320
#define	BP_INTERRUPT	321
#define	BP_LIBRARY	322
#define	BP_OBJECT	323
#define	BP_OVERLAY	324
#define	BP_PRIVATE	325
#define	BP_PUBLIC	326
#define	BP_RESIDENT	327
#define	BP_SHL	328
#define	BP_SHR	329
#define	BP_UNIT	330
#define	BP_USES	331
#define	BP_XOR	332
#define	ALL	333
#define	RENAME	334
#define	SYMMETRIC_DIFF	335
#define	STRING_KEYWORD	336
#define	IMPLEMENTATION	337
#define	INTERFACE	338
#define	D_ASMNAME	339
#define	D_ATTRIBUTE	340
#define	D_C	341
#define	D_C_LANGUAGE	342
#define	D_EXTERN	343
#define	D_OVERRIDE	344
#define	D_STATIC	345
#define	BP_ABSOLUTE	346
#define	BP_VIRTUAL	347
#define	r_WRITE	348
#define	r_READ	349
#define	r_INITFDR	350
#define	r_LAZYGET	351
#define	r_COLLECT	352
#define	r_POW	353
#define	r_EXPON	354
#define	z_ARCTAN	355
#define	z_COS	356
#define	z_EXP	357
#define	z_LN	358
#define	z_SIN	359
#define	z_SQRT	360
#define	z_POW	361
#define	z_EXPON	362
#define	p_INPUT	363
#define	p_OUTPUT	364
#define	p_REWRITE	365
#define	p_RESET	366
#define	p_PUT	367
#define	p_GET	368
#define	p_WRITE	369
#define	p_READ	370
#define	p_WRITELN	371
#define	p_READLN	372
#define	p_PAGE	373
#define	p_NEW	374
#define	p_DISPOSE	375
#define	p_ABS	376
#define	p_SQR	377
#define	p_SIN	378
#define	p_COS	379
#define	p_EXP	380
#define	p_LN	381
#define	p_SQRT	382
#define	p_ARCTAN	383
#define	p_TRUNC	384
#define	p_ROUND	385
#define	p_PACK	386
#define	p_UNPACK	387
#define	p_ORD	388
#define	p_CHR	389
#define	p_SUCC	390
#define	p_PRED	391
#define	p_ODD	392
#define	p_EOF	393
#define	p_EOLN	394
#define	p_MAXINT	395
#define	p_TRUE	396
#define	p_FALSE	397
#define	p_EXTEND	398
#define	p_UPDATE	399
#define	p_SEEKWRITE	400
#define	p_SEEKREAD	401
#define	p_SEEKUPDATE	402
#define	p_READSTR	403
#define	p_WRITESTR	404
#define	p_BIND	405
#define	p_UNBIND	406
#define	p_HALT	407
#define	p_GETTIMESTAMP	408
#define	p_ARG	409
#define	p_RE	410
#define	p_IM	411
#define	p_CARD	412
#define	p_CMPLX	413
#define	p_POLAR	414
#define	p_EMPTY	415
#define	p_POSITION	416
#define	p_LASTPOSITION	417
#define	p_LENGTH	418
#define	p_SUBSTR	419
#define	p_TRIM	420
#define	p_EQ	421
#define	p_LT	422
#define	p_GT	423
#define	p_NE	424
#define	p_LE	425
#define	p_GE	426
#define	p_BINDING	427
#define	p_DATE	428
#define	p_TIME	429
#define	p_MAXCHAR	430
#define	p_MAXREAL	431
#define	p_MINREAL	432
#define	p_EPSREAL	433
#define	bp_ASSIGN	434
#define	bp_GETMEM	435
#define	bp_FREEMEM	436
#define	bp_INC	437
#define	bp_DEC	438
#define	bp_NEAR	439
#define	bp_FAR	440
#define	PXSC_OPERATOR	441
#define	gpc_ASSIGNTYPE	442
#define	gpc_MIN	443
#define	gpc_MAX	444
#define	STANDARD_OUTPUT	445
#define	STANDARD_INPUT	446
#define	op_COPY	447
#define	op_NULL	448
#define	op_ROOT	449
#define	op_SELF	450
#define	op_TEXTWRITABLE	451
#define	ASM_KEYWORD	452
#define	BREAK	453
#define	CONTINUE	454
#define	p_INDEX	455
#define	p_MARK	456
#define	p_RELEASE	457
#define	RETURN	458
#define	RESULT	459
#define	EXIT	460
#define	DEFAULT	461
#define	OTHERS	462
#define	p_CLOSE	463
#define	SIZEOF	464
#define	ALIGNOF	465
#define	TYPEOF	466
#define	ANDAND	467
#define	CONJUGATE	468
#define	p_DEFINESIZE	469
#define	INLINE	470
#define	EXTERNAL	471
#define	ASMNAME	472
#define	VOLATILE	473
#define	STATIC	474
#define	G_CONST	475
#define	TQ_BYTE	476
#define	TQ_SHORT	477
#define	TQ_LONG	478
#define	TQ_LONGLONG	479
#define	TQ_UNSIGNED	480
#define	UNSIGNED_INTEGER	481
#define	STRING_LITERAL	482
#define	CHAR_LITERAL	483
#define	UNSIGNED_REAL	484
#define	GTE	485
#define	LTE	486
#define	NEQ	487
#define	EXPON	488
#define	CARET	489
#define	CONST_EQUAL	490
#define	CEILPLUS	491
#define	CEILMINUS	492
#define	CEILMULT	493
#define	CEILRDIV	494
#define	FLOORPLUS	495
#define	FLOORMINUS	496
#define	FLOORMULT	497
#define	FLOORRDIV	498
#define	ASSIGN	499
#define	LBRACKET	500
#define	RBRACKET	501
#define	TWODOTS	502
#define	ELLIPSIS	503
#define	UNIMPLEMENTED	504


extern YYSTYPE yylval;
#define YYEMPTY		-2
