{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//                IO.H IMPORT UNIT for GPC                              //}
{//                                                                      //}
{//  v1.00 - by Dr Abimbola A. Olowofoyeku (The African Chief);          //}
{//                                                                      //}
{//  This package is released as part of the GNU Pascal project.         //}
{//                                                                      //}
{//  NOTE - SOME OF THE ROUTINES IN THIS UNIT MAY NOT WORK CORRECTLY.    //}
{//  TEST CAREFULLY AND USE WITH CARE !!!                                //}
{//                                                                      //}
{//  This library is a free library; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  v1.00, May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk               //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}

UNIT IO;

INTERFACE

USES GPCTYPES;

{$W-}

function chsize ( handle : Integer;
                size : LongInt ) : Integer; C;

function _close ( _fd : Integer ) : Integer; C;

function _creat ( _path : PChar;
                _attrib : Integer ) : Integer; C;

function crlf2nl ( _buffer : PChar;
                 _length : SSIZE_T ) : SSIZE_T; C;

function _dos_lock ( _fd : Integer; 
                   _offset : LongInt; 
                   _length : LongInt ) : Integer; C;

function filelength ( _handle : Integer ) : LongInt; C;

function _get_dev_info ( _arg : Integer ) : ShortInt; C;

function lock ( _fd : Integer; 
              _offset : LongInt;
              _length : LongInt ) : Integer; C;

function _open ( _path : PChar;
               _oflag : Integer ) : Integer; C;

function _read ( _fd : Integer;
               Var _buf;
               _nbyte : SIZE_T ) : SSIZE_T; C;

function setmode ( _fd : Integer;
                 _newmode : Integer ) : Integer; C;

function tell ( _fd : Integer ) : OFF_T; C;

function _dos_unlock ( _fd : Integer;
                     _offset : LongInt;
                     _length : LongInt ) : Integer; C;

function unlock ( _fd : Integer; 
                _offset : LongInt;
                _length : LongInt ) : Integer; C;

function _write ( _fd : Integer;
                Var   _buf;
                _nbyte : SIZE_T ) : SSIZE_T; C;

function _chmod ( _path : PChar;
                _func : Integer; 
                _attrib : integer ) : Integer; C;

procedure _flush_disk_cache; C;

function open ( path : PChar; { portable }
               oflag, mode : Integer ) : Integer; C;

Function sOpen ( path : pChar;access, shflag, mode : integer ) : integer;


IMPLEMENTATION

Function sOpen ( path : pChar;access, shflag, mode : integer ) : integer;
Begin
    sOpen := open ( path, ( ( access ) or ( shflag ) ), mode );
End;

End.
