{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//                PC.H IMPORT UNIT for GPC                              //}
{//                                                                      //}
{//  v1.00 - by Dr Abimbola A. Olowofoyeku (The African Chief);          //}
{//                                                                      //}
{//  This package is released as part of the GNU Pascal project.         //}
{//                                                                      //}
{//  NOTE - SOME OF THE ROUTINES IN THIS UNIT MAY NOT WORK CORRECTLY.    //}
{//  TEST CAREFULLY AND USE WITH CARE !!!                                //}
{//                                                                      //}
{//  This library is a free library; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  v1.00, May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk               //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}
UNIT PC;

INTERFACE

USES GPCTYPES;
{$W-}

function inportb ( _port : Byte ) : Byte; C;

function inportw ( _port : Byte ) : Byte; C;

function inportl ( _port : Byte ) : LongInt; C;

procedure inportsb ( _port : Byte; 
                   Var _buf : Byte;
                   _len : Word ); C;

procedure inportsw ( _port : Byte;
                   Var _buf : Byte;
                   _len : Word ); C;

procedure inportsl ( _port : Byte;
                   Var _buf : LongInt;
                   _len : Word ); C;

procedure outportb ( _port : Byte;
                   _data : Byte ); C;

procedure outportw ( _port : Byte;
                   _data : Byte ); C;

procedure outportl ( _port : Byte;
                   _data : LongInt ); C;

procedure outportsb ( _port : Byte;
                    Var _buf : Byte;
                    _len : Word ); C;

procedure outportsw ( _port : Byte;
                    Var _buf : Byte;
                    _len : Word ); C;

procedure outportsl ( _port : Byte;
                    Var _buf : LongInt;
                    _len : Word ); C;


function inp ( _port : Byte ) : Byte; C;

function inpw ( _port : Byte ) : Byte; C;

procedure outp ( _port : Byte;
               _data : Byte ); C;

procedure outpw ( _port : Byte;
                _data : Byte ); C;
function getkey : Integer; C;
{= ALT's have 0x100 set }

function getxkey : Integer; C;
{= ALT's have 0x100 set, 0xe0 sets 0x200 }


{
function kbhit: Integer; C;
procedure sound(_frequency: Integer); C;
Procedure nosound;
}

{
Const ScreenPrimary = _go32_info_block.linear_address_of_primary_screen;
Const ScreenSecondary = _go32_info_block.linear_address_of_secondary_screen;
}

function ScreenMode : Integer; C;

function ScreenRows : Integer; C;

function ScreenCols : Integer; C;

procedure ScreenPutChar ( _ch : Integer;
                        _attr : Integer;
                        _x : Integer;
                        _y : Integer ); C;

procedure ScreenGetChar ( Var _ch : Integer;
                        Var _attr : Integer;
                        _x : Integer;
                        _y : Integer ); C;

procedure ScreenPutString ( _ch : PChar;
                          _attr : Integer; 
                          _x : Integer; 
                          _y : Integer ); C;

procedure ScreenSetCursor ( _row : Integer; 
                          _col : Integer ); C;

procedure ScreenGetCursor ( Var _row : Integer;
                          Var _col : Integer ); C;

procedure ScreenClear; C;

procedure ScreenUpdate ( Var  _virtual_screen ); C;

procedure ScreenUpdateLine ( Var _virtual_screen_line;
                           _row : Integer ); C;

procedure ScreenRetrieve ( Var _virtual_screen ); C;

procedure ScreenVisualBell; C;

IMPLEMENTATION
{
Procedure nosound;
begin
  sound ( 0 );
end;
}
end.
