{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//                STRING.H IMPORT UNIT for GPC                          //}
{//                                                                      //}
{//  v1.00 - by Dr Abimbola A. Olowofoyeku (The African Chief);          //}
{//                                                                      //}
{//  This package is released as part of the GNU Pascal project.         //}
{//                                                                      //}
{//  NOTE - SOME OF THE ROUTINES IN THIS UNIT MAY NOT WORK CORRECTLY.    //}
{//  TEST CAREFULLY AND USE WITH CARE !!!                                //}
{//                                                                      //}
{//  This library is a free library; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  v1.00, May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk               //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}
UNIT STRINGH;

INTERFACE

USES GPCTYPES;
{$W-}

Function memchr ( Const s;
                 c : Integer;
                 n : SIZE_T ) : Pointer; C;

function memcmp ( Const s1;
                 Const s2;
                 n : SIZE_T ) : Integer; C;

Function  memcpy ( Var dest;
                 Const src;
                 n : SIZE_T ) : Pointer; C;

Function  memmove ( Var s1;
                  Const s2;
                  n : SIZE_T ) : Pointer; C;

Function  memset ( Var s;
                 c : Integer;
                 n : SIZE_T ) : Pointer; C;


function _strlen ( s : PChar ) : SIZE_T; AsmName 'strlen';
function _strcat ( s1 : PChar;
                 s2 : PChar ) : PChar; AsmName 'strcat';

function strchr ( s : PChar;
                 c : Integer ) : PChar; C;

function strcmp ( s1 : PChar;
                 s2 : PChar ) : Integer; C;

function strcoll ( s1 : PChar;
                 s2 : PChar ) : Integer; C;

function strcpy ( s1 : PChar;
                s2 : PChar ) : PChar; C;

function strcspn ( s1 : PChar;
                  s2 : PChar ) : SIZE_T; C;

function strerror ( ercode : Integer ) : PChar; C;


function strncat ( s1 : PChar;
                 s2 : PChar;
                 n : SIZE_T ) : PChar; C;

function strncmp ( s1 : PChar;
                 s2 : PChar;
                 n : SIZE_T ) : Integer; C;

function strncpy ( s1 : PChar;
                 s2 : PChar;
                 n : SIZE_T ) : PChar; C;

function strpbrk ( s1 : PChar;
                 s2 : PChar ) : PChar; C;

function strrchr ( s : PChar;
                 c : char ) : PChar; C;

function strspn ( s1 : PChar;
                 s2 : PChar ) : SIZE_T; C;

function strstr ( s1 : PChar;
                 s2 : PChar ) : PChar; C;

function strtok ( s1 : PChar;
                s2 : PChar ) : PChar; C;

function strxfrm ( s1 : PChar;
                 s2 : PChar;
                 n : SIZE_T ) : SIZE_T; C;

function bcmp ( Const ptr1;
              Const ptr2;
              len : Integer ) : Integer; C;

Function bcopy ( Const a;
                Var b;
                len : SIZE_T ) : Pointer; C;

Function bzero ( Var ptr;
                len : SIZE_T ) : Pointer; C;

function ffs ( mask : Integer ) : Integer; C;

function index ( sstr : PChar;
               c : Integer ) : PChar; C;

Function memccpy ( Var xto;
                  Const xfrom;
                  c : Integer;
                  n : SIZE_T ) : Pointer; C;

function rindex ( sstr : PChar;
                 c : Integer ) : PChar; C;

function stpcpy ( dest : PChar;
                src : PChar ) : PChar; C;

function strdup ( s : PChar ) : PChar; C;

function strlwr ( s : PChar ) : PChar; C;

function strcasecmp ( s1 : PChar;
                     s2 : PChar ) : Integer; C;

function stricmp ( s1 : PChar;
                  s2 : PChar ) : Integer; C;

function strncasecmp ( s1 : PChar;
                      s2 : PChar;
                      n : SIZE_T ) : Integer; C;

function strnicmp ( s1 : PChar;
                   s2 : PChar;
                   n : SIZE_T ) : Integer; C;

function strsep ( Var stringp : PChar;
                 delim : PChar ) : PChar; C;

function strupr ( s : PChar ) : PChar; C;


IMPLEMENTATION


end.
