{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//         TEST PROGRAM for GPC - TESTS THE GPC OBJECTS UNIT            //}
{//                                                                      //}
{//         By Dr Abimbola A. Olowofoyeku (The African Chief);           //}
{//                                                                      //}
{//  This test program is released as part of the GNU Pascal project,    //}
{//  for the SOLE purpose of testing the routines in certain units.      //}
{//                                                                      //}
{//  This program is a free program; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk                      //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}
PROGRAM TestObj;

USES OBJECTS;

Type
pNewObj = ^TNewObj;
TNewObj = Object ( TObject )
   Constructor Create ( aOwner : pObject );
end; {* TNewObj *}

Constructor TNewObj.Create;
Begin
  Inherited Create ( aOwner );
  Name   := 'Object Child';
  Handle := 2000;
End;  {* TNewObj.Create *}


{ Program() }
Var
ThisObj : TObject;

Begin
  Writeln ( 'Hello World. Program Begins Here!' );
  Writeln ( '---------------------------------' );
  ThisObj.Create ( Nil );

  With ThisObj
  do begin
     Name    := 'Object Number 1';
     Handle  := 1000;
     Child   := New ( pNewObj, Create ( @ThisObj ) );
     Writeln ( 'My SelfID    = ', integer ( SelfID ) );
     Writeln ( 'My Handle    = ', integer ( Handle ) );
     Writeln ( 'My name      = ', Name );
     Writeln ( 'Child SelfID = ', integer ( Child^.SelfID ) );
     Writeln ( 'Child Handle = ', integer ( Child^.Handle ) );
     Writeln ( 'Child name   = ', Child^.Name );
     Writeln ( 'Child PARENT SelfID = ', integer ( Child^.Parent^.SelfID ) );
     Writeln ( 'Child PARENT Handle = ', integer ( Child^.Parent^.Handle ) );
     Child^.Free;
     Done;
  end; {* With ThisObj *}

  Writeln ( '---------------------------------' );
  Writeln ( 'Hello World. Program Ends Here!!' );
End.
