{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//         TEST PROGRAM FOR GPC - TESTS THE SYSUTILS UNIT               //}
{//                                                                      //}
{//         By Dr Abimbola A. Olowofoyeku (The African Chief);           //}
{//                                                                      //}
{//  This test program is released as part of the GNU Pascal project,    //}
{//  for the SOLE purpose of testing the routines in certain units.      //}
{//                                                                      //}
{//  This program is a free program; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk                      //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}
program TESTSYS;

USES
GPCTYPES, SYSTEM, SYSUTILS;
{$W-}

var
j, k : Integer;
s : String;

Begin

   While ( 0 = 0 )
   do begin
      Write ( 'filename (ENTER to quit): ' );
      Readln ( s );
      if s = '' then Halt;

      Writeln ( 'FullName     = ', ExpandFileName ( s ) );
      Writeln ( 'exists       = ', FileExists ( s ) );
      Writeln ( 'Extension    = ', ExtractFileExt ( s ) );
      Writeln ( 'New Extension= ', ChangeFileExt ( s, 'CHF' ) );
      Writeln ( 'UpperCase    = ', UpperCase ( s ) );
      Writeln ( 'LowerCase    = ', LowerCase ( s ) );
      Writeln ( 'File Age     = ', FileAge ( s ) );

      k := FileOpen ( s , fmOpenRead );
      Writeln ( 'File Handle  = ', k );

      j := FileGetDate (  k );
      Writeln ( 'File Date    = ', j );
      Writeln ( 'File Size    = ', FileSize ( k ) );

      FileClose ( k );
   end;
End.
