{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//                     TIMER UNIT for GPC                               //}
{//                                                                      //}
{//  v1.00 - by Dr Abimbola A. Olowofoyeku (The African Chief);          //}
{//                                                                      //}
{//  This package is released as part of the GNU Pascal project.         //}
{//                                                                      //}
{//  NOTE - SOME OF THE ROUTINES IN THIS UNIT MAY NOT WORK CORRECTLY.    //}
{//  TEST CAREFULLY AND USE WITH CARE !!!                                //}
{//                                                                      //}
{//  This library is a free library; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  v1.00, May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk               //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}
UNIT Timer;

INTERFACE

USES
{$ifdef __GPC__}GPCTYPES, {$endif}DOS;

Procedure ClockOn;  { start the clock }
Procedure ClockOff; { stop the clock }
Function  RealInterval : Real;  { interval - real type }
Function  Interval   : Integer; { interval - Integer type }

{////////////////////////////////}
{////////////////////////////////}
{////////////////////////////////}
IMPLEMENTATION
{////////////////////////////////}
{////////////////////////////////}
{////////////////////////////////}

Var
h, m, s, s100 : word;
StartClock, StopClock : real;
Elapsed : Real {$ifdef __GPC__}value -1.0{$endif};

Procedure ClockOn;
begin
    GetTime ( h, m, s, s100 );
    StartClock := ( h * 3600 ) + ( m * 60 ) + s + ( s100 / 100 );
end;{* ClockOn *}
{////////////////////////////////}
Procedure Clockoff;
begin
    GetTime ( h, m, s, s100 );
    StopClock := ( h * 3600 ) + ( m * 60 ) + s + ( s100 / 100 );
    Elapsed := ( stopclock - startclock );
end;{* Clockoff *}
{////////////////////////////////}
Function RealInterval : Real;
begin
    RealInterval := Elapsed;
end;{* RealInterval *}
{////////////////////////////////}
Function Interval : Integer;
Begin
    Interval := Round ( Elapsed );
End;{* Interval *}
{////////////////////////////////}
{////////////////////////////////}
{////////////////////////////////}
{////////////////////////////////}
End.
