{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//               EXTRA "SYSTEM STUFF" UNIT for GPC                      //}
{//                                                                      //}
{//  v1.00 - by Dr Abimbola A. Olowofoyeku (The African Chief);          //}
{//                                                                      //}
{//  This package is released as part of the GNU Pascal project.         //}
{//  NOTE - SOME OF THE ROUTINES IN THIS UNIT MAY NOT WORK CORRECTLY.    //}
{//  TEST CAREFULLY AND USE WITH CARE.                                   //}
{//                                                                      //}
{//  This library is a free library; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  v1.00, May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk               //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}
UNIT XSYSTEM;

INTERFACE

USES GPCTYPES;
{$W-}

{ memory allocation that can be resized by further calls }
Procedure MemAlloc ( Var xptr; size : integer ); AsmName 'realloc';

{ free memory allocated with MemAlloc }
Procedure MemFree ( Var xptr ); AsmName 'free';

{ return a unique name for a temporary file }
Function TempFileName ( Name : pChar ) : pChar;
AsmName 'tmpnam';

{ Set file access permissions
L_IWRITE          	(Permission to write)
L_IREAD           	(Permission to read)
L_IREAD or L_IWRITE  	(Permission to read and write)
}
Function ChangeFileMode ( Path : pChar; Mode : integer ) : integer;
AsmName 'chmod';

{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
IMPLEMENTATION
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
End.
